using System;
class Program
{


    static void Main()
    {
        int N = int.Parse(Console.ReadLine());
        string[] s = Console.ReadLine().Split();
        int O = int.Parse(s[0]);
        int A = int.Parse(s[1]);
        int B = int.Parse(s[2]);
        int AB = int.Parse(s[3]);
        int O1 = 0;
        int A1 = 0;
        int B1 = 0;
        int AB1 = 0;
        int[] jedinica = new int[N];
        string[] krv = new string[N];
        int j = 0; bool yes = true;
        int[,] N4 = new int[N, 4];







        for (int i = 0; i < N; i++)
        {
            string[] s1 = Console.ReadLine().Split();
            jedinica[i] = int.Parse(s1[1]);
            krv[i] = s1[0];
            if ("O" == krv[i])
            {
                if (jedinica[i] <= O)
                {
                    O -= jedinica[i];
                    N4[i, 0] = jedinica[i];
                    jedinica[i] = 0;
                }
                else yes = false;
            }
            else if ("A" == krv[i])
            {
                if (jedinica[i] <= A)
                {
                    A -= jedinica[i];
                    N4[i, 1] = jedinica[i];
                    jedinica[i] = 0;

                }
                else if (jedinica[i] <= A + O)
                {
                    A = 0;
                    N4[i, 1] = A;
                    jedinica[i] -= A;
                    O -= jedinica[i];
                    N4[i, 0] = jedinica[i];
                    jedinica[i] = 0;
                }
                else if (jedinica[i] > A + O) yes = false;


            }
            if ("B" == krv[i])
            {
                if (jedinica[i] <= B)
                {
                    B -= jedinica[i];
                    N4[i, 2] = jedinica[i];
                    jedinica[i] = 0;

                }
                else if (jedinica[i] <= B + O)
                {

                    
                    N4[i, 2] = B;
                    jedinica[i] -= B;
                    B = 0;

                    O -= jedinica[i];
                    N4[i, 0] = jedinica[i];
                    jedinica[i] = 0;
                }
                else if (jedinica[i] > B + O) yes = false;
            }
            
        }
        for(int i = 0; i < N; i++)
        {
            if ("AB" == krv[i])
            {
                if (jedinica[i] <= AB)
                {
                    AB -= jedinica[i];
                    N4[i, 3] = jedinica[i];
                    jedinica[i] = 0;

                }
                else if (jedinica[i] <= AB + O && O != 0)
                {

                    N4[i, 3] = AB;
                    jedinica[i] -= AB;
                    AB = 0;
                    O -= jedinica[i];
                    N4[i, 0] = jedinica[i];
                    jedinica[i] = 0;
                }
                else if (jedinica[i] <= AB + B && B != 0)
                {
                    AB = 0;
                    N4[i, 3] = AB;
                    jedinica[i] -= AB;
                    B -= jedinica[i];
                    N4[i, 2] = jedinica[i];
                    jedinica[i] = 0;
                }
                else if (jedinica[i] <= AB + A && A != 0)
                {
                    AB = 0;
                    N4[i, 3] = AB;
                    jedinica[i] -= AB;
                    A -= jedinica[i];
                    N4[i, 1] = jedinica[i];
                    jedinica[i] = 0;
                }
                else if (jedinica[i] <= AB + A + O && A != 0 && O != 0)
                {
                    jedinica[i] -= AB;
                    N4[i, 3] = AB;
                    AB = 0;

                    jedinica[i] -= A;
                    N4[i, 1] = A;
                    A = 0;

                    O -= jedinica[i];
                    N4[i, 0] = jedinica[i];
                    jedinica[i] = 0;
                }
                else if (jedinica[i] <= AB + B + O && B != 0 && O != 0)
                {
                    jedinica[i] -= AB;
                    N4[i, 3] = AB;
                    AB = 0;

                    jedinica[i] -= B;
                    N4[i, 2] = B;
                    B = 0;

                    O -= jedinica[i];
                    N4[i, 0] = jedinica[i];
                    jedinica[i] = 0;
                }
                else if (jedinica[i] <= AB + A + B + O && A != 0 && O != 0 && B != 0)
                {
                    jedinica[i] -= AB;
                    N4[i, 3] = AB;
                    AB = 0;



                    jedinica[i] -= B;
                    N4[i, 2] = B;
                    B = 0;

                    jedinica[i] -= A;
                    N4[i, 1] = A;
                    A = 0;

                    O -= jedinica[i];
                    N4[i, 0] = jedinica[i];
                    jedinica[i] = 0;
                }
                else yes = false;
            }
        }



        if (yes)
        {
            Console.WriteLine("moguce");
            for (int i = 0; i < N; i++)
            {
                for (j = 0; j < 4; j++)
                {
                    Console.Write(N4[i, j] + " ");
                }
                Console.WriteLine();
            }
        }
        else Console.WriteLine("nemoguce");

    }
}